﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Storage.Streams;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Media.Imaging;

namespace e_teaching.Converters
{
    public class ByteToImageConverter : IValueConverter
    {
        
            // This converts the value object to the string to display.
            // This will work with most simple types.
            public object Convert(object value, Type targetType, object parameter, string language)
            {
                byte[] rawImage = value as byte[];

                using (InMemoryRandomAccessStream ms = new InMemoryRandomAccessStream())
                {
                    using (DataWriter writer = new DataWriter(ms.GetOutputStreamAt(0)))
                    {
                        writer.WriteBytes((byte[])rawImage);

                        // The GetResults here forces to wait until the operation completes
                        // (i.e., it is executed synchronously), so this call can block the UI.
                        writer.StoreAsync().GetResults();
                    }

                    BitmapImage image = new BitmapImage();
                    image.SetSource(ms);
                    return image;
                }
        }

            // No need to implement converting back on a one-way binding
            public object ConvertBack(object value, Type targetType,
                object parameter, string language)
            {
                throw new NotImplementedException();
            }
        
    }
}
